import java.awt.*;
import java.awt.event.*;
import java.applet.AudioClip;
import java.net.*;
import java.awt.image.*;

public class Game extends java.applet.Applet implements Runnable, KeyListener
{
    private final static
        shape.Size window = new shape.Size(470,370);

    private game.Debug debug = new game.Debug();
    private game.Ground ground;
    private game.Camera camera;
    private game.Player player;
    private game.Rockets rockets = new game.Rockets();
    private game.History history;
    // private AudioClip music;
    private String charPressed = "";
    private URL sourcePath;
    private game.Input input = new game.Input();
    private game.Space space;

    private Image imgBuffer;
    private Graphics bufferGraph;

    // _____________________

    Thread killme = null;

    public Game()
    {
        addKeyListener(this);
    }

    public void start()
    {
        setAll();
        if( killme == null )
        {
            killme = new Thread(this);
            killme.start();
        }
    }

    public void stop()
    {
      	killme = null;
    }

    public void run()
    {
        while (killme != null)
        {
            try { Thread.sleep(70); }
            catch (InterruptedException e) {}

            updateAll();
        }
        killme = null;
    }

    // _____________________

    public void keyPressed(KeyEvent event)
    {
        input.setInput(event);
    }
    public void keyReleased(KeyEvent event)
    {
    }
    public void keyTyped(KeyEvent event)
    {
    }

    // _____________________

    private void setAll()
    {
        requestFocus();
        this.setBackground( new Color(0,0,0) );
        sourcePath = getDocumentBase();
        history = new game.History();
        camera = new game.Camera( window );
        ground = new game.Ground( window.width*6, window.height*6, 0,0,0 );
        player = new game.Player();
        player.position( new shape.Point(800,800) );
        space = new game.Space(ground);

        camera.position( player.getPoint() );
        ground.setPosition(0,0);

        /* music = getAudioClip( getCodeBase(), "sound/music.au" );
           music.loop();
        */
    }

    private void updateAll()
    {
        actAll();
        drawBuffer();
        repaint();
    }

    private void actAll()
    {
        player.act( ground, input, rockets );
        rockets.act( ground );
        camera.act( ground, player.getPoint() );
        input.clear();
    }

    private void drawBuffer()
    {
        imgBuffer = createImage(window.width,window.height);
        bufferGraph = imgBuffer.getGraphics();

        space.appear( bufferGraph, ground, camera );
        player.appear( bufferGraph, ground, camera );
        rockets.appear( bufferGraph, ground, camera );
    }

    public void paint(Graphics graph)
    {
        graph.drawImage(imgBuffer, 0, 0, this);
    }
}
