package art;
import java.awt.*;

public class Art implements game.Directions
{
    private Color col = new Color(255,255,255);

    protected shape.Grid grid = new shape.Grid();
    protected final int maxPoints = getMaxPoints();
    
    protected int polyX[] = new int[maxPoints+1];
    protected int polyY[] = new int[maxPoints+1];

    private shape.Rotation rotation = new shape.Rotation();

    public void setColor(int red, int green, int blue)
    {
        col = new Color(red,green,blue);
    }
    public void implementColor(Graphics graph)
    {
        graph.setColor(col);
    }

    protected int getMaxPoints()
    {
        return 3;
    }
    protected void calculate(shape.Point pos, shape.Size _size)
    {
        grid.calculate(pos, _size);
    }

    protected void setPolyDirection(int facing)
    {
        switch (facing)
        {
            case FACING_UP:
                break;
            case FACING_RIGHT:
                rotatePoly( shape.Rotation.ROTATION_RIGHT );
                break;
            case FACING_DOWN:
                rotatePoly( shape.Rotation.ROTATION_HALF_CIRCLE );
                break;
            case FACING_LEFT:
                rotatePoly( shape.Rotation.ROTATION_LEFT );
                break;
        }
    }

    protected void rotatePoly(int rotateType)
    {
        int i;
        shape.PointInt point = new shape.PointInt();
        for ( i = 0; i<= maxPoints; i++ )
        {
            point.x = polyX[i];
            point.y = polyY[i];
            switch ( rotateType )
            {
                case shape.Rotation.ROTATION_RIGHT:
                    rotation.rotatePointRight(
                        point, grid.mid.x, grid.mid.y);
                case shape.Rotation.ROTATION_HALF_CIRCLE:
                    rotation.rotatePointHalfCircle(
                        point, grid.mid.x, grid.mid.y);
                case shape.Rotation.ROTATION_LEFT:
                    rotation.rotatePointLeft(
                        point, grid.mid.x, grid.mid.y);
            }
            polyX[i] = point.x;
            polyY[i] = point.y;
        }
    }

    protected void draw(Graphics graph, shape.Point pos, shape.Size _size, int facing)
    {
        setPoly(pos, _size, facing);
        drawPoly(graph);
    }
    protected void setPoly(shape.Point pos, shape.Size _size, int facing)
    {
        calculate(pos, _size);
        setPolyShape();
        setPolyDirection(facing);
    }

    public void drawPoly(Graphics graph)
    {
        graph.setColor(col);
        graph.fillPolygon(polyX, polyY, maxPoints);
    }

    protected void setPolyShape()
    {
    }
}
