package art;

public class GunsArt extends AnimatedArt
{
    public GunsArt()
    {
        animation.setLoopBehavior(Animation.LOOP_BACK);
        animation.setLoopRepeatBehavior(Animation.LOOP_REPEAT_ONCE);
        animation.setMaxCell(5);
        setColor(150, 200, 250);
    }

    public void doShoot()
    {
        animation.reset();
    }

    protected int getMaxPoints()
    {
        return 8;
    }

    protected void setPolyShape(int cell)
    {
        polyX[0] = grid.rect.left;
        polyY[0] = grid.rect.bottom;

        polyX[1] = polyX[0];
        polyY[1] = grid.mid.y + cell*2;

        polyX[2] = polyX[0] + grid.bigStep;
        polyY[2] = polyY[1];

        polyX[3] = polyX[2];
        polyY[3] = grid.rect.bottom - grid.step;

        polyX[4] = grid.rect.right - grid.bigStep;
        polyY[4] = polyY[3];
        
        polyX[5] = polyX[4];
        polyY[5] = polyY[1];

        polyX[6] = grid.rect.right;
        polyY[6] = polyY[5];

        polyX[7] = polyX[6];
        polyY[7] = polyY[0];
    }

}
