package art;
import java.awt.*;

public class ShipArt implements Actions
{
    private int action = ACTION_UNDEFINED;
    private DriveArt driveArt = new DriveArt();
    private HullArt hullArt = new HullArt();
    private GunsArt gunsArt = new GunsArt();
    private CabinArt cabinArt = new CabinArt();

    public void draw(Graphics graph, shape.Point pos, shape.Size _size, int facing)
    {
        driveArt.draw(graph, pos, _size, facing);
        hullArt.draw(graph, pos, _size, facing);
        gunsArt.draw(graph, pos, _size, facing);
        cabinArt.draw(graph, pos, _size, facing);
    }

    public void setAction(int _action)
    {
        if ( action != _action )
        {
            action = _action;
            actionDidChange();
        }
    }

    public void actionDidChange()
    {
        if ( action == ACTION_SPEEDING )
            driveArt.turnOnFire();
        else
            driveArt.turnOffFire();

        if ( action == ACTION_ATTACKING )
            gunsArt.doShoot();
    }

}
