package game;
import java.awt.*;

public class Ground extends shape.Rectangle
{
    private int colR = 0, colG = 0, colB = 0;
    private int offsetX = 0, offsetY = 0;
    private boolean doFillRect = false;

    public Ground(int _width, int _height, int _colR, int _colG, int _colB)
    {
        super(0,0,_width,_height);
        colR = _colR;
        colG = _colG;
        colB = _colB;
    }
    public Ground(int _width, int _height)
    {
        super(0,0,_width,_height);
    }

    public int getOffsetX()
    {
        return offsetX;
    }

    public int getOffsetY()
    {
        return offsetY;
    }

    public void setPosition(int _offsetX, int _offsetY)
    {
        offsetX = _offsetX;
        offsetY = _offsetY;
    }

    public void setFilled(boolean _doFillRect)
    {
        doFillRect = _doFillRect;
    }

    public void appear(Graphics graph)
    {
        graph.setColor( new Color(colR,colG,colB) );

        if ( doFillRect )
            graph.fillRect ( left+offsetX, top+offsetY, getWidth(), getHeight() );
        else
            graph.drawRect( left+offsetX, top+offsetY, getWidth(), getHeight() );
    }

    public shape.Rectangle getRectangle()
    {
        return new shape.Rectangle( left, top, right, bottom );
    }

}