package shape;

public class Size
{
    public int width = 0, height = 0;

    public Size(int _width, int _height)
    {
        width = _width;
        height = _height;
    }
    public Size(double _width, double _height)
    {
        width = (int) _width;
        height = (int) _height;
    }
    public Size(shape.Rectangle rect)
    {
        width = rect.getWidth();
        height = rect.getHeight();
    }
    public Size(int _size)
    {
        width = _size;
        height = _size;
    }
    public Size()
    {
    }
    
    public void setSize(int _width, int _height)
    {
        width = _width;
        height = _height;
    }
    public void setSize(double _width, double _height)
    {
        width = (int) _width;
        height = (int) _height;
    }
    
    public Point getMidPoint(int x, int y)
    {
        return new Point(
            x+width / 2,
            y+height / 2 );
    }
    public int getRight(int x)
    {
        return x+width;
    }
    public int getBottom(int y)
    {
        return y+height;
    }
    public Size getHalf()
    {
        return new Size( width/2, height/2 );
    }

}